> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/containers/managed-kubernetes/use-cases/optimize-kubernetes-deployments.md).

# Optimize Kubernetes Deployments for Compute Resources and Storage Volumes

Optimize Kubernetes deployments for compute resources and storage volumes on IONOS CLOUD: zone-based resource allocation for performance and fault tolerance.

You can optimize the compute resources, such as CPU and RAM, along with storage volumes in Kubernetes through strategic usage of zones.To enhance the performance of your Kubernetes environment, consider implementing a strategic approach for resource allocation. You can intelligently distribute workloads across different zones to improve performance and enhance fault tolerance and resilience.

## Example

Define a storage class named `ionos-enterprise-ssd-zone-1`, which specifies the provisioning of **Performance**-type storage with `ext4` file system format, located in availability zone `ZONE_2`. Configure the `volumeBindingMode` and `allowVolumeExpansion` fields.

```yaml
apiVersion: storage.k8s.io/v1
kind: StorageClass
metadata:
  annotations:
    storageclass.kubernetes.io/is-default-class: "false"
  name: ionos-enterprise-ssd-zone-1
provisioner: cloud.ionos.com
parameters:
  type: Performance
  fstype: ext4
  availabilityZone: ZONE_2
volumeBindingMode: WaitForFirstConsumer
allowVolumeExpansion: true
```

{% hint style="info" %}
**Note**: Supported values for `fstype` are `ext2`, `ext3` or `ext4`.
{% endhint %}

This implementation provides a robust and reliable Kubernetes infrastructure for your applications.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.ionos.com/cloud/containers/managed-kubernetes/use-cases/optimize-kubernetes-deployments.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
